### Method

# Clutter Event get_source_device

#### Declaration [src]

    ClutterInputDevice*
    clutter_event_get_source_device (
      const ClutterEvent* event
    )

#### Description [src]

Retrieves the hardware device that originated the event.

If you need the virtual device, use `clutter_event_get_device()`.

If no hardware device originated this event, this function will return the same device as `clutter_event_get_device()`.

#### Return value

Type: `ClutterInputDevice`

A pointer to a `ClutterInputDevice` or `NULL`.

The returned data is owned by the instance.